#include "smtp.h"

/* memoryalert module */

extern smtpi jtin;

void smtp_sa_mtq(void *arg)
   {
   smtp_tu par_tu= (smtp_tu) arg;
   xmlnode loLimit;
   int liLimit,liCurrent,liDiff,liSeconds,liStart,liTotalTime;
   long llTimeNow;
   float lfCurrent;
   struct rusage  loUsage;

   if (jtin->sa->ijabberd_reset==1 || jtin->sa->itransport_reset==1)
      (*(smtp_j2s_cb)NULL)(NULL, NULL); // call procedure for generating so->x

   // kontrola pamti transportu
   if ((loLimit=xmlnode_get_tag(jtin->config,"core/systemalert/transport/memory"))!=NULL)
      {
      liCurrent=pool_size(jtin->i->p)+smtp_PoolsGetMem();

      // kontrola na prvn mez
      if ((liLimit=j_atoi(xmlnode_get_attrib(loLimit,"firstlimit"),0))>0)
         {
         if ((liCurrent/(1024*1024))>=liLimit)
            {
            if (jtin->sa->itransport_first==0)
               {
               smtp_SendInfoToAdmin(spools(par_tu->p,"Transport - first memory limit exceed: ",smtp_itoa(par_tu->p,liCurrent),".",par_tu->p),SMTP_SITA_M );
               jtin->sa->itransport_first=1;
               }
            }
         else
            jtin->sa->itransport_first=0;
         }


      // kontrola na restartovac mez
      if ((liLimit=j_atoi(xmlnode_get_attrib(loLimit,"resetlimit"),0))>0 &&
          jtin->sa->itransport_last>0 && liCurrent/(1024*1024)>=liLimit )
         {
         smtp_SendInfoToAdmin(spools(par_tu->p,"Transport - reset memory limit exceed: ",smtp_itoa(par_tu->p,liCurrent),".",par_tu->p),SMTP_SITA_M );
         jtin->sa->itransport_reset=1;
         }

      // kontrola na dal opakovanou mez
      if ((liLimit=j_atoi(xmlnode_get_attrib(loLimit,"differentiallimit"),0))>0 &&
          jtin->sa->itransport_first==1 && jtin->sa->itransport_reset==0 &&
          (liDiff=liCurrent-jtin->sa->itransport_last)>0 &&
          liDiff/(1024*1024)>=liLimit)
         {
         smtp_SendInfoToAdmin(spools(par_tu->p,"Transport - next memory limit exceed: ",smtp_itoa(par_tu->p,liCurrent),".",par_tu->p),SMTP_SITA_M );
         }

      jtin->sa->itransport_last=liCurrent;
      }

   // kontrola pamti jabberd
   if ((loLimit=xmlnode_get_tag(jtin->config,"core/systemalert/jabberd/memory"))!=NULL)
      {
      getrusage(RUSAGE_SELF,&loUsage);
      liCurrent=loUsage.ru_maxrss*1024;
      // kontrola na prvn mez
      if ((liLimit=j_atoi(xmlnode_get_attrib(loLimit,"firstlimit"),0))>0)
         {
         if ((liCurrent/(1024*1024))>=liLimit)
            {
            if (jtin->sa->ijabberd_first==0)
               {
               smtp_SendInfoToAdmin(spools(par_tu->p,"Jabberd - first memory limit exceed: ",smtp_itoa(par_tu->p,liCurrent),".",par_tu->p),SMTP_SITA_M );
               jtin->sa->ijabberd_first=1;
               }
            }
         else
            jtin->sa->ijabberd_first=0;
         }

      // kontrola na restartovac mez
      if ((liLimit=j_atoi(xmlnode_get_attrib(loLimit,"resetlimit"),0))>0 &&
          jtin->sa->ijabberd_last>0 && liCurrent/(1024*1024)>=liLimit )
         {
         smtp_SendInfoToAdmin(spools(par_tu->p,"Jabberd - reset memory limit exceed: ",smtp_itoa(par_tu->p,liCurrent),".",par_tu->p),SMTP_SITA_M );
         jtin->sa->ijabberd_reset=1;
         }

      // kontrola na dal opakovanou mez
      if ((liLimit=j_atoi(xmlnode_get_attrib(loLimit,"differentiallimit"),0))>0 &&
          jtin->sa->ijabberd_first==1 && jtin->sa->ijabberd_reset==0 &&
          (liDiff=liCurrent-jtin->sa->ijabberd_last)>0 &&
          liDiff/(1024*1024)>=liLimit)
         {
         smtp_SendInfoToAdmin(spools(par_tu->p,"Jabberd - next memory limit exceed: ",smtp_itoa(par_tu->p,liCurrent),".",par_tu->p),SMTP_SITA_M );
         }

      jtin->sa->ijabberd_last=liCurrent;
      }


   // kontrola CPU load jabberd
   if ((loLimit=xmlnode_get_tag(jtin->config,"core/systemalert/jabberd/cpuload"))!=NULL)
      {
      getrusage(RUSAGE_SELF,&loUsage);
/*
   struct sysinfo  loSysInfo;
      sysinfo(&loSysInfo);
  SMTP_DEBUG(SMTP_ZONE,"uptime %i %i",loSysInfo.uptime,jtin->tStart);
  SMTP_DEBUG(SMTP_ZONE,"totalram %i",loSysInfo.totalram);
  SMTP_DEBUG(SMTP_ZONE,"procs %i",loSysInfo.procs);
      liSeconds=(loSysInfo.uptime*HZ-jtin->tStart)/HZ;
  SMTP_DEBUG(SMTP_ZONE,"liSeconds %i",liSeconds);
//      liStart = llTimeNow - liSeconds;
      liTotalTime = loUsage.ru_utime.tv_usec + loUsage.ru_stime.tv_usec;
  SMTP_DEBUG(SMTP_ZONE,"liTotalTime %i",liTotalTime);
      liCurrent = liSeconds ? (liTotalTime * 10 * 100/HZ) / liSeconds : 0;
  SMTP_DEBUG(SMTP_ZONE,"liCurrent %i",liCurrent);
      if (liCurrent > 999) liCurrent = 999;
  SMTP_DEBUG(SMTP_ZONE,"liCurrent %i",liCurrent);
      lfCurrent= (float)liCurrent/10;
*/


      lfCurrent=((((float)loUsage.ru_utime.tv_usec) + (float)(loUsage.ru_stime.tv_usec)) / (float)((time(NULL)-jtin->tStart)*HZ))/10 ;

//  SMTP_DEBUG(SMTP_ZONE,"lfCurrent %.lf",lfCurrent/10);

/*
      seconds = (((GL_current_time * HZ) - p->start_time) / HZ);
      start = GL_time_now - seconds;
      total_time = (p->utime + p->stime  + 
                   (CL_Sum ?   p->cutime + p->cstime : 0));
      pcpu = seconds ? (total_time * 10 * 100/HZ) / seconds : 0;
*/


      // kontrola na prvn mez
      if ((liLimit=j_atoi(xmlnode_get_attrib(loLimit,"limit"),0))>0)
         {
         if (lfCurrent>=liLimit)
            {
            if (jtin->sa->icpu_first==1 && (time(NULL)-jtin->sa->cpu_time)/60>=j_atoi(xmlnode_get_attrib(loLimit,"time"),0))
               {
               if (jtin->sa->icpu_alert==0)
                  smtp_SendInfoToAdmin(spools(par_tu->p,"Jabberd - first memory limit exceed: ",smtp_itoa(par_tu->p,liCurrent),".",par_tu->p),SMTP_SITA_M );
               else
                  jtin->sa->icpu_alert=1;
               }

            if (jtin->sa->icpu_first==0)
               {
               jtin->sa->icpu_first=1;
               jtin->sa->cpu_time=time(NULL);
               }
            }
         else
            jtin->sa->icpu_first=0;
         }

//      smtp_SendInfoToAdmin(spools(par_tu->p,"Jabberd - CPU load: ",smtp_ftoa(par_tu->p,lfCurrent),".",par_tu->p),SMTP_SITA_M );
      }
   
   pool_free(par_tu->p);
   }




// create new thread for getting
result smtp_sa_daemon(void *arg)
   {
   pool p=pool_new();
   smtp_PoolsReg(8000, p);

   smtp_tu par_tu;

   par_tu=pmalloco(p, sizeof(_smtp_tu));
   par_tu->p=p;

   par_tu->q=mtq_new(p);
   mtq_send(par_tu->q, p, smtp_sa_mtq, (void *)par_tu);
   return r_DONE;
   }
